// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/recovery
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/files -i Files -t ../../../assets/templates/middleware/recovery -o recovering_middleware.go -l ""

import (
	"context"
	"fmt"

	"git.perx.ru/perxis/perxis-go/pkg/files"
	"go.uber.org/zap"
)

// recoveringMiddleware implements files.Files that is instrumented with logging
type recoveringMiddleware struct {
	logger *zap.Logger
	next   files.Files
}

// RecoveringMiddleware instruments an implementation of the files.Files with simple logging
func RecoveringMiddleware(logger *zap.Logger) Middleware {
	return func(next files.Files) files.Files {
		return &recoveringMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *recoveringMiddleware) AbortUpload(ctx context.Context, upload *files.MultipartUpload) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.AbortUpload(ctx, upload)
}

func (m *recoveringMiddleware) CompleteUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.CompleteUpload(ctx, upload)
}

func (m *recoveringMiddleware) DeleteFile(ctx context.Context, file *files.File) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.DeleteFile(ctx, file)
}

func (m *recoveringMiddleware) GetFile(ctx context.Context, file *files.File) (f *files.File, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.GetFile(ctx, file)
}

func (m *recoveringMiddleware) MoveUpload(ctx context.Context, upload *files.MultipartUpload) (file *files.File, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.MoveUpload(ctx, upload)
}

func (m *recoveringMiddleware) StartUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.StartUpload(ctx, upload)
}

func (m *recoveringMiddleware) Upload(ctx context.Context, file *files.File) (u *files.Upload, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Upload(ctx, file)
}
